//
//  UICheckBox.h
//  Less2Do
//
//  Created by Matthias Tretter on 26.11.09.
//  Copyright 2009 BIAC. All rights reserved.
//

#import <UIKit/UIKit.h>

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark Custom Control representing a CheckBox
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////


@interface UICheckBox : UIControl {
	// the image to display
	UIImageView* backgroundImage;
	// the state of the checkbox
	BOOL on;
	// the name of the On-Image
	NSString *imageNameOn;
	// the name of the Off-Image
	NSString *imageNameOff;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark Properties
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

@property (nonatomic, retain, readwrite) UIImageView* backgroundImage;
@property (nonatomic, copy) NSString *imageNameOn;
@property (nonatomic, copy) NSString *imageNameOff;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark Methods
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

- (id)initWithFrame:(CGRect)frame;  
- (id)initWithFrame:(CGRect)frame andOnImage:(NSString *)imageOn andOffImage:(NSString *)imageOff;

- (void)setOn:(BOOL)on; 
- (BOOL)isOn;

- (void)setupUserInterface;
- (void)toggle;

@end
